-#!/bin/sh
-# Please do not edit this file. It is generated automatically from
-# configure.in and a configure template.
-configdirs=
-
#!/bin/sh
-# Configuration script template
+# Configuration script
# Copyright (C) 1988, 1990, 1991 Free Software Foundation, Inc.
#This file is part of GNU.
# $Id$
+# Please email any bugs, comments, and/or additions to this file to:
+
#
# Shell script to create proper links to machine-dependent files in
# preparation for compilation.
# config.status is removed.
#
+export PATH || (echo "OOPS, this isn't sh. Desperation time. I will feed myself to sh."; sh $0 $argv; kill $$)
+
+#set -e
+
remove=rm
hard_link=ln
symbolic_link='ln -s'
#hard_link="echo ln"
#symbolic_link="echo ln -s"
-progname=$0
-
# clear some things potentially inherited from environment.
+
+Makefile=Makefile
+Makefile_in=Makefile.in
ansi=
+arguments=$*
+commontargets=
+configdirs=
+ddestdir=
defaulttargets=
destdir=
fatal=
hostsubdir=
-Makefile=Makefile
-Makefile_in=Makefile.in
-norecurse=
-recursing=
+idestdir=
+next_ddestdir=
+next_destdir=
+next_idestdir=
+next_objdir=
+next_site=
+next_target=
+next_tmpdir=
+norecursion=
+objdir=
+objdiroption=
+progname=
+recurring=
removing=
srcdir=
srctrigger=
target=
targets=
-commontargets=
targetsubdir=
-template=
verbose=
-
+# or maybe grab from gcc/version.c
+version_path="1.95.02"
for arg in $*;
do
- case ${arg} in
- -ansi | +a*)
- ansi=true
- clib=clib
- ;;
- -destdir=* | +destdir=* | +destdi=* | +destd=* | +dest=* | +des=* | +de=* | +d=*)
- destdir=`echo ${arg} | sed 's/[+-]d[a-z]*=//'`
- ;;
- -languages=* | +languages=* | +language=* | +languag=* \
- | +langua=* | +langu=* | +lang=* | +lan=* | +la=* \
- | +l=*)
- languages="${languages} `echo ${arg} | sed 's/[+-]l[a-z]*=//'`"
- ;;
- -gas | +g*)
- gas=yes
- ;;
- -help | +h*)
- fatal=true
- ;;
- -nfp | +nf*)
- nfp=yes
- ;;
- -norecurse | +no*)
- norecurse=true
- ;;
- -recursing)
- recursing=true
- ;;
- -rm | +r*)
- removing=${arg}
- ;;
-# -srcdir=* | +srcdir=* | +srcdi=* | +srcd=* | +src=* | +sr=* | +s=*)
-# srcdir=`echo ${arg} | sed 's/[+-]s[a-z]*=//'`
-# ;;
- -subdirs | +f* | +su*)
- subdirs=${arg}
- ;;
- -target=* | +target=* | +targe=* | +targ=* | +tar=* | +ta=*)
+ # handle things that might have args following as separate words
+ if [ -n "${next_ddestdir}" ] ; then ddestdir=${arg} ; next_ddestdir=
+ elif [ -n "${next_destdir}" ] ; then destdir=${arg} ; next_destdir= ; ddestdir=${destdir} ; idestdir=${destdir}
+ elif [ -n "${next_idestdir}" ] ; then idestdir=${arg} ; next_idestdir=
+ elif [ -n "${next_objdir}" ] ; then objdir=${arg} ; next_objdir=
+ elif [ -n "${next_site}" ] ; then site=${arg} ; next_site=
+ elif [ -n "${next_target}" ] ; then
+ next_target=
if [ -n "${targets}" ] ; then
subdirs="+subdirs"
fi
- newtargets="${targets} `echo ${arg} | sed 's/[+-]t[a-z]*=//'`"
+ newtargets="${targets} ${arg}"
targets="${newtargets}"
- ;;
- -template=* | +template=* | +templat=* | +templa=* | +templ=* | +temp=* | +tem=* | +te=*)
- template=`echo ${arg} | sed 's/[+-]template=//'`
- ;;
- -v | -verbose | +v*)
- verbose=${arg}
- ;;
- -* | +*)
- (echo ;
- echo "Unrecognized option: \"${arg}\"". ;
- echo) 1>&2
- fatal=true
- ;;
- *)
- if [ -n "${hosts}" ] ; then
- subdirs="+subdirs"
- fi
- newhosts="${hosts} ${arg}"
- hosts=${newhosts}
- ;;
- esac
+ elif [ -n "${next_tmpdir}" ] ; then
+ next_tmpdir=
+ tmpdiroption="+tmpdir=${arg}"
+ TMPDIR=${arg}
+
+ else
+ case ${arg} in
+ -ansi | +a*)
+ ansi=true
+ clib=clib
+ ;;
+ -noversion | +noversion)
+ version_path=""
+ ;;
+ -ddestdir=* | +ddestdir=* | +ddestdi=* | +ddestd=* | +ddest=* | +ddes=* | +dde=* | +dd=*)
+ ddestdir=`echo ${arg} | sed 's/[+-]dd[a-z]*=//'`
+ ;;
+ -ddestdir | +ddestdir | +ddestdi | +ddestd | +ddest | +ddes | +dde | +dd)
+ next_ddestdir=yes
+ ;;
+ -destdir=* | +destdir=* | +destdi=* | +destd=* | +dest=* | +des=* | +de=*)
+ destdir=`echo ${arg} | sed 's/[+-]d[a-z]*=//'`
+ ddestdir=${destdir}
+ idestdir=${destdir}
+ ;;
+ -destdir | +destdir | +destdi | +destd | +dest | +des | +de)
+ next_destdir=yes
+ ;;
+ -gas | +g*)
+ gas=yes
+ ;;
+ -help | +h*)
+ fatal=true
+ ;;
+ -idestdir=* | +idestdir=* | +idestdi=* | +idestd=* | +idest=* | +ides=* | +ide=* | +id=*)
+ idestdir=`echo ${arg} | sed 's/[+-]id[a-z]*=//'`
+ ;;
+ -idestdir | +idestdir | +idestdi | +idestd | +idest | +ides | +ide | +id)
+ next_idestdir=yes
+ ;;
+ -languages=* | +languages=* | +language=* | +languag=* \
+ | +langua=* | +langu=* | +lang=* | +lan=* | +la=* \
+ | +l=*)
+ languages="${languages} `echo ${arg} | sed 's/[+-]l[a-z]*=//'`"
+ ;;
+ -nfp | +nf*)
+ nfp=yes
+ ;;
+ -norecursion | +no*)
+ norecursion=true
+ ;;
+ -objdir=* | +objdir=* | +objdi=* | +objd=* | +obj=* | +ob=* | +o=*)
+ objdiroption=${arg}
+ objdir=`echo ${arg} | sed 's/[+-]o[a-z]*=//'`
+ ;;
+ -objdir | +objdir | +objdi | +objd | +obj | +ob | +o)
+ next_objdir=yes
+ ;;
+ -recurring | +recurring | +recurrin | +recurri | +recurr | +recur | +recu | +rec | +re)
+ recurring=true
+ arguments=`echo ${arguments} | sed "s:${arg}::"`
+ ;;
+ -rm | +rm)
+ removing=${arg}
+ ;;
+ -site=* | +site=* | +sit=* | +si=*)
+ site=`echo ${arg} | sed 's/[+-]s[a-z]*=//'`
+ ;;
+ -site | +site | +sit | +si)
+ next_site=yes
+ ;;
+ # -srcdir=* | +srcdir=* | +srcdi=* | +srcd=* | +src=* | +sr=*)
+ # srcdir=`echo ${arg} | sed 's/[+-]s[a-z]*=//'`
+ # ;;
+ -subdirs | +su*)
+ subdirs=${arg}
+ ;;
+ -target=* | +target=* | +targe=* | +targ=* | +tar=* | +ta=*)
+ if [ -n "${targets}" ] ; then
+ subdirs="+subdirs"
+ fi
+
+ newtargets="${targets} `echo ${arg} | sed 's/[+-]t[a-z]*=//'`"
+ targets="${newtargets}"
+ ;;
+ -target | +target | +targe | +targ | +tar | +ta)
+ next_target=yes
+ ;;
+ -tmpdir=* | +tmpdir=* | +tmpdi=* | +tmpd=* | +tmp=* | +tm=*)
+ tmpdiroption=${arg}
+ TMPDIR=`echo ${arg} | sed 's/[+-]t[a-z]*=//'`
+ ;;
+ -tmpdir | +tmpdir | +tmpdi | +tmpd | +tmp | +tm)
+ next_tmpdir=yes
+ ;;
+ -v | -verbose | +v*)
+ verbose=${arg}
+ ;;
+ -* | +*)
+ (echo ;
+ echo "Unrecognized option: \"${arg}\"". ;
+ echo) 1>&2
+ fatal=true
+ ;;
+ *)
+ if [ -n "${hosts}" ] ; then
+ subdirs="+subdirs"
+ fi
+
+ newhosts="${hosts} ${arg}"
+ hosts=${newhosts}
+ ;;
+ esac
+ fi
done
if [ -n "${verbose}" ] ; then
- echo `pwd`/configure $*
+ echo $0 $*
+fi
+
+## this is a little touchy and won't always work, but...
+##
+## if the argv[0] starts with a slash then it is an absolute name that can be
+## used as is.
+##
+## otherwise, if argv[0] has no slash in it, we can assume that it is on the
+## path. Since PATH might include "." we also add `pwd` to the end of PATH.
+##
+## otherwise we prepend `pwd` to $0 and hope that will give us an absolute
+## path.
+##
+
+if (echo $0 | grep '^/' > /dev/null) ; then
+ progname=$0
+else
+ if (echo $0 | grep '/' > /dev/null) ; then
+ progname=`pwd`/$0
+ else
+ progname=$0
+ PATH=$PATH:`pwd` ; export PATH
+ fi
+fi
+
+configsub=`echo ${progname} | sed 's/configure$/config.sub/'`
+
+if ${configsub} none >/dev/null 2>&1 ; then
+ true
+else
+ echo '***' cannot find config.sub.
+ echo 1
fi
-# process host and target only if not rebuilding configure itself or removing.
-if [ -z "${template}" -a -z "${removing}" -a -z "${fatal}" ] ; then
+# process host and target only if not removing.
+if [ -z "${removing}" -a -z "${fatal}" ] ; then
# Complain if an arg is missing
if [ -z "${hosts}" ] ; then
(echo ;
echo ;
echo "Options: [defaults in brackets]" ;
echo " +ansi configure w/ANSI library. [no ansi lib]" ;
- echo " +destdir=MYDIR configure for installation into MYDIR. [/usr/local]" ;
- echo " +subdirs configure in subdirectories. [in source directories]" ;
- echo " +lang=LANG configure to build LANG. [gcc]" ;
- echo " +help print this message. [normal config]" ;
+ echo " +ddestdir=MYDIR configure for installation host dependent files" ;
+ echo " into MYDIR. [\"/usr/local\"]" ;
+ echo " +idestdir=MYDIR configure for installation host independent files" ;
+ echo " into MYDIR. [\"/usr/local\"]" ;
+ echo " +destdir=MYDIR configure for installation of both host dependent and" ;
+ echo " host independent files into MYDIR. [\"/usr/local\"]" ;
echo " +gas configure the compilers for use with gas. [native as]" ;
+ echo " +help print this message. [normal config]" ;
+ echo " +lang=LANG configure to build LANG. [gcc]" ;
echo " +nfp configure the compilers default to soft floating point. [hard float]" ;
- echo " +norecurse configure this directory only. [recurse]" ;
+ echo " +norecursion configure this directory only. [recurse]" ;
+ echo " +objdir=ODIR configure in a parallel tree rooted in ODIR. [rooted in \".\"]" ;
echo " +rm remove this configuration. [build a configuration]" ;
+ echo " +site configure with site specific makefile" ;
+# This is correctly aligned in the output, even though it isn't here.
+ echo " +subdirs configure in subdirectories. [in source directories]" ;
echo " +target=TARGET configure for TARGET. [TARGET = HOST]" ;
- echo " +template=TEM rebuild configure using TEM. [normal config]" ;
+ echo " +tmpdir=TMPDIR create temporary files in TMPDIR. [ TMPDIR = \"/tmp\" ]" ;
echo ;
echo "Where HOST and TARGET are something like \"vax\", \"sun3\", \"encore\", etc." ;
echo "Asking for more than one \"+target\" implies \"+subdirs\". Any other" ;
exit 1
fi
-#### configure.in common parts come in here.
-# This file is a shell script fragment that supplies the information
-# necessary to tailor a template configure script into the configure
-# script appropriate for this directory. For more information, check
-# any existing configure script.
-
-configdirs="libiberty bfd binutils bison gcc readline ld gas gnulib ${clib} gdb make grep diff prms "
-srctrigger=README.configure
-srcname="gnu development package"
-
-## end of common part.
-
-# are we rebuilding config itself?
-if [ -n "${template}" ] ; then
- if [ ! -r ${template} ] ; then
- echo '***' "Can't find template ${template}." 1>&2
+### break up configure.in.
+if [ -r configure.in ] ; then
+ if [ -z "`grep '^# per\-host:' configure.in`" ] ; then
+ echo '***' `pwd`/configure.in has no "per-host:" line. 1>&2
exit 1
fi
-# prep the template
- sed -e '/^#### configure.in common parts come in here.$/,/^## end of common part.$/c\
-#### configure.in common parts come in here.\
-## end of common part.' \
- -e '/^#### configure.in per-host parts come in here.$/,/^## end of per-host part.$/c\
-#### configure.in per-host parts come in here.\
-## end of per-host part.' \
- -e '/^#### configure.in per-target parts come in here.$/,/^## end of per-target part.$/c\
-#### configure.in per-target parts come in here.\
-## end of per-target part.' \
- -e '/^#### configure.in post-target parts come in here.$/,/^## end of post-target part.$/c\
-#### configure.in post-target parts come in here.\
-## end of post-target part.' \
- < ${template} > template.new
-
- if [ -r configure.in ] ; then
- if [ -z "`grep '^# per\-host:' configure.in`" ] ; then
- echo '***' `pwd`/configure.in has no "per-host:" line. 1>&2
- exit 1
- fi
-
- if [ -z "`grep '^# per\-target:' configure.in`" ] ; then
- echo '***' `pwd`/configure.in has no "per-target:" line. 1>&2
- exit 1
- fi
-
- # split configure.in into common, per-host, per-target,
- # and post-target parts. Post-target is optional.
- sed -e '/^# per\-host:/,$d' configure.in > configure.com
- sed -e '1,/^# per\-host:/d' -e '/^# per\-target:/,$d' configure.in > configure.hst
- if grep -s '^# post-target:' configure.in ; then
- sed -e '1,/^# per\-target:/d' -e '/^# post\-target:/,$d' configure.in > configure.tgt
- sed -e '1,/^# post\-target:/d' configure.in > configure.pos
- else
- sed -e '1,/^# per\-target:/d' configure.in > configure.tgt
- echo >configure.pos
- fi
-
- # and insert them
- sed -e '/^#### configure.in common parts come in here.$/ r configure.com' \
- -e '/^#### configure.in per\-host parts come in here.$/ r configure.hst' \
- -e '/^#### configure.in per\-target parts come in here.$/ r configure.tgt' \
- -e '/^#### configure.in post\-target parts come in here.$/ r configure.pos' \
- template.new > configure.new
-
- rm -f configure.com configure.tgt configure.hst configure.pos
- else
- echo Warning: no configure.in in `pwd`
- cat ${template} >> configure
+ if [ -z "`grep '^# per\-target:' configure.in`" ] ; then
+ echo '***' `pwd`/configure.in has no "per-target:" line. 1>&2
+ exit 1
fi
- chmod a+x configure.new
- rm template.new
-# mv configure configure.old
- mv configure.new configure
-
- if [ -n "${verbose}" ] ; then
- echo Rebuilt configure in `pwd`
+ if [ -z "${TMPDIR}" ] ; then
+ TMPDIR=/tmp ; export TMPDIR
fi
- # Now update config.sub from the template directory.
- if echo "$template" | grep -s 'configure$' ; then
- cp `echo "$template" | sed s/configure$/config.sub/` ./config.sub.new
- # mv config.sub config.sub.old
- mv config.sub.new config.sub
+ # keep this filename short for &%*%$*# 14 char file names
+ tmpfile=${TMPDIR}/cONf$$
- if [ -n "${verbose}" ] ; then
- echo Rebuilt config.sub in `pwd`
- fi
+ # split configure.in into common, per-host, per-target,
+ # and post-target parts. Post-target is optional.
+ sed -e '/^# per\-host:/,$d' configure.in > ${tmpfile}.com
+ sed -e '1,/^# per\-host:/d' -e '/^# per\-target:/,$d' configure.in > ${tmpfile}.hst
+ if grep '^# post-target:' configure.in >/dev/null ; then
+ sed -e '1,/^# per\-target:/d' -e '/^# post\-target:/,$d' configure.in > ${tmpfile}.tgt
+ sed -e '1,/^# post\-target:/d' configure.in > ${tmpfile}.pos
+ else
+ sed -e '1,/^# per\-target:/d' configure.in > ${tmpfile}.tgt
+ echo >${tmpfile}.pos
fi
- if [ -z "${norecurse}" ] ; then
- # If template is relative path, make it absolute for recursing.
- if echo "${template}" | grep -s '^/' ; then
- true
- else
- template=`pwd`/${template}
- fi
-
- while [ -n "${configdirs}" ] ; do
- # set configdir to car of configdirs, configdirs to cdr of configdirs
- set ${configdirs}; configdir=$1; shift; configdirs=$*
-
- if [ "`echo ${configdir}.*`" != "${configdir}.*" ] ; then
- targetspecificdirs=${configdir}.*
- else
- targetspecificdirs=
- fi
+else
+ echo '***' No configure.in in `pwd`
+ exit 1
+fi
- for i in ${configdir} ${targetspecificdirs} ; do
- if [ -d $i ] ; then
- if [ -r $i/configure ] ; then
- (cd $i ;
- ./configure +template=${template} ${verbose})
- else
- echo Warning: No configure script in `pwd`/$i
- fi
- else
- if [ -n "${verbose}" ] ; then
- echo Warning: directory $i is missing.
- fi
- fi
- done
- done
- fi
+### do common part of configure.in
- exit 0
-fi
+. ${tmpfile}.com
# some sanity checks on configure.in
if [ -z "${srctrigger}" ] ; then
- echo Warning: srctrigger not set in configure.in. `pwd` not configured.
+ echo '***' srctrigger not set in `pwd`/configure.in.
exit 1
fi
defaulttargets=true
fi
- result=`/bin/sh ./config.sub ${host}`
+ host_alias=${host}
+
+ result=`${configsub} ${host}`
host_cpu=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\1/'`
host_vendor=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\2/'`
host_os=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\3/'`
host=${host_cpu}-${host_vendor}-${host_os}
- host_makefile_frag=config/hmake-${host}
-
-#### configure.in per-host parts come in here.
+ host_makefile_frag=config/mh-${host}
+ if [ ! -f ${host_makefile_frag} ]
+ then
+ host_makefile_frag=config/mh-${host_alias}
+ fi
-## end of per-host part.
+ . ${tmpfile}.hst
for target in ${targets} ; do
- result=`/bin/sh ./config.sub ${target}`
+ target_alias=${target}
+ result=`${configsub} ${target}`
target_cpu=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\1/'`
target_vendor=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\2/'`
target_os=`echo $result | sed 's/^\(.*\)-\(.*\)-\(.*\)$/\3/'`
target=${target_cpu}-${target_vendor}-${target_os}
- target_makefile_frag=config/tmake-${target}
-
-#### configure.in per-target parts come in here.
+ target_makefile_frag=config/mt-${target}
+ if [ ! -f ${target_makefile_frag} ]
+ then
+ target_makefile_frag=config/mt-${target_alias}
+ fi
-#
-# Local Variables:
-# fill-column: 131
-# End:
-#
-## end of per-target part.
+ . ${tmpfile}.tgt
- # Temporarily, we support only direct subdir builds.
- hostsubdir=Host-${host}
- targetsubdir=Target-${target}
+ hostsubdir=H-${host_alias}
+ targetsubdir=T-${target_alias}
if [ -n "${removing}" ] ; then
+ if [ -n "${objdir}" ] ; then
+ echo '***' +rm not supported for +objdir. Just \"rm -rf ${objdir}\" by hand.
+ exit 1
+ fi
+
if [ -n "${subdirs}" ] ; then
if [ -d "${hostsubdir}" ] ; then
rm -rf ${hostsubdir}/${targetsubdir}
- if [ -z "`(ls ${hostsubdir}) 2>&1 | grep Target- | grep -v Target-independent`" ] ; then
+ if [ -z "`(ls ${hostsubdir}) 2>&1 | grep T- | grep -v T-independent`" ] ; then
rm -rf ${hostsubdir}
fi
else
rm -f ${Makefile} config.status ${links}
fi
else
+ if [ -n "${objdir}" ]; then
+ srcdir=`pwd`
+ cd ${objdir}
+ fi
+
if [ -n "${subdirs}" ] ; then
# check for existing status before allowing forced subdirs.
if [ -f ${Makefile} ] ; then
if [ -z "${commontargets}" ] ; then
mkdir ${targetsubdir}
else
- if [ ! -d Target-independent ] ; then
- mkdir Target-independent
+ if [ ! -d T-independent ] ; then
+ mkdir T-independent
fi
- ${symbolic_link} Target-independent ${targetsubdir}
+ ${symbolic_link} T-independent ${targetsubdir}
fi # if target independent
fi # if no target dir yet
cd ${targetsubdir}
- srcdir=../..
+ if [ -z "${srcdir}" ] ; then
+ srcdir=../..
+ fi
else
# if not subdir builds, then make sure none exist.
- if [ -n "`(ls .) 2>&1 | grep Host-`" ] ; then
+ if [ -n "`(ls .) 2>&1 | (grep H- ; true)`" ] ; then
echo '***' "Configured subdirs exist. `pwd` not configured." 1>&2
exit 1
+ else
+ true
fi
fi
fi
# set target, host, VPATH
- echo "host = ${host}" >> ${Makefile}
- echo "target = ${target}" >> ${Makefile}
+ echo "host_alias = ${host_alias}" >> ${Makefile}
+ echo "host_cpu = ${host_cpu}" >> ${Makefile}
+ echo "host_vendor = ${host_vendor}" >> ${Makefile}
+ echo "host_os = ${host_os}" >> ${Makefile}
+ echo "version_path = ${version_path}" >> ${Makefile}
+ echo "target_alias = ${target_alias}" >> ${Makefile}
+ echo "target_cpu = ${target_cpu}" >> ${Makefile}
+ echo "target_vendor = ${target_vendor}" >> ${Makefile}
+ echo "target_os = ${target_os}" >> ${Makefile}
if [ -n "${subdirs}" ] ; then
- echo "subdir = /${hostsubdir}/${targetsubdir}" >> ${Makefile}
+ (echo "subdir = /${hostsubdir}/${targetsubdir}" ;
+ echo "unsubdir = ../..") >> ${Makefile}
else
- echo "subdir =" >> ${Makefile}
+ (echo "subdir =" ;
+ echo "unsubdir = .") >> ${Makefile}
fi
# echo "workdir = `pwd`" >> ${Makefile}
# add "Makefile.in" (or whatever it's called)
cat ${srcdir}/${Makefile_in} >> ${Makefile}
+ # Conditionalize the makefile for this site.
+ if [ -n "${site}" ] ; then
+ site_makefile_frag=config/ms-${site}
+
+ if [ -f ${srcdir}/${site_makefile_frag} ] ; then
+ (echo "site_makefile_frag = ${srcdir}/${site_makefile_frag}" ;
+ sed -e "/^####/ r ${srcdir}/${site_makefile_frag}" ${Makefile}) > Makefile.tem
+ else
+ (echo "site_makefile_frag =" ;
+ cat ${Makefile}) > Makefile.tem
+ fi
+ mv Makefile.tem ${Makefile}
+ fi
+
# Conditionalize the makefile for this host.
if [ -f ${srcdir}/${host_makefile_frag} ] ; then
- sed -e "/^####/ r ${srcdir}/${host_makefile_frag}" ${Makefile} > Makefile.tem
- mv Makefile.tem ${Makefile}
+ (echo "host_makefile_frag = ${srcdir}/${host_makefile_frag}" ;
+ sed -e "/^####/ r ${srcdir}/${host_makefile_frag}" ${Makefile}) > Makefile.tem
+ else
+ (echo "host_makefile_frag =" ;
+ cat ${Makefile}) > Makefile.tem
fi
+ mv Makefile.tem ${Makefile}
# Conditionalize the makefile for this target.
if [ -f ${srcdir}/${target_makefile_frag} ] ; then
- sed -e "/^####/ r ${srcdir}/${target_makefile_frag}" ${Makefile} > Makefile.tem
- mv Makefile.tem ${Makefile}
+ (echo "target_makefile_frag = ${srcdir}/${target_makefile_frag}" ;
+ sed -e "/^####/ r ${srcdir}/${target_makefile_frag}" ${Makefile}) > Makefile.tem
+ else
+ (echo "target_makefile_frag =" ;
+ cat ${Makefile}) > Makefile.tem
fi
+ mv Makefile.tem ${Makefile}
# set srcdir
sed "s@^srcdir = \.@srcdir = ${srcdir}@" ${Makefile} > Makefile.tem
mv Makefile.tem ${Makefile}
- # set destdir
- if [ -n "${destdir}" ] ; then
- sed "s:^destdir =.*$:destdir = ${destdir}:" ${Makefile} > Makefile.tem
+ # set ddestdir
+ if [ -n "${ddestdir}" ] ; then
+ sed "s:^ddestdir =.*$:ddestdir = ${ddestdir}:" ${Makefile} > Makefile.tem
+ mv Makefile.tem ${Makefile}
+ fi
+
+ # set idestdir
+ if [ -n "${idestdir}" ] ; then
+ sed "s:^idestdir =.*$:idestdir = ${idestdir}:" ${Makefile} > Makefile.tem
mv Makefile.tem ${Makefile}
fi
sed "s:^NONSUBDIRS =.*$:NONSUBDIRS = ${noconfigdirs}:" ${Makefile} > Makefile.tem
mv Makefile.tem ${Makefile}
+ # remove any form feeds.
+ sed -e "s/\f//" ${Makefile} > Makefile.tem
+ mv Makefile.tem ${Makefile}
+
using=
if [ -f ${srcdir}/${host_makefile_frag} ] ; then
- using=" using \"${host_makefile_frag}\""
+ using="${using} and \"${host_makefile_frag}\""
fi
-
if [ -f ${srcdir}/${target_makefile_frag} ] ; then
- if [ -z "${using}" ] ; then
- andusing=" using \"${target_makefile_frag}\""
- else
- andusing="${using} and \"${target_makefile_frag}\""
- fi
- else
- andusing=${using}
+ using="${using} and \"${target_makefile_frag}\""
+ fi
+ if [ -n "${site}" -a \
+ -f ${srcdir}/${site_makefile_frag} ] ; then
+ using="${using} and \"${site_makefile_frag}\""
fi
+ using=`echo "${using}" | sed 's/and/using/'`
+ using="Created \"${Makefile}\" in `pwd`${using}."
- if [ -n "${verbose}" -o -z "${recursing}" ] ; then
- echo "Created \"${Makefile}\"" in `pwd`${andusing}.
+ if [ -n "${verbose}" -o -z "${recurring}" ] ; then
+ echo ${using}
fi
-#### configure.in post-target parts come in here.
+ . ${tmpfile}.pos
-## end of post-target part.
+ # describe the chosen configuration in config.status.
+ # Make that file a shellscript which will reestablish
+ # the same configuration. Used in Makefiles to rebuild
+ # Makefiles.
- if [ "${host}" = "${target}" ] ; then
- echo "Links are now set up for use with a ${target}." \
- > config.status
- # | tee ${srcdir}/config.status
- else
- echo "Links are now set up for host ${host} and target ${target}." \
- > config.status
- # | tee ${srcdir}/config.status
- fi
+ echo "#!/bin/sh
+# `pwd` was configured as follows:
+(cd ${srcdir} ; ${progname}" ${arguments} `if [ -z "${norecursion}" ] ; then echo +norecursion ; else true ; fi` ")
+# ${using}" > config.status
+ chmod a+x config.status
originaldir=`pwd`
cd ${srcdir}
fi
# If there are subdirectories, then recurse.
- if [ -z "${norecurse}" -a -n "${configdirs}" ] ; then
+ if [ -z "${norecursion}" -a -n "${configdirs}" ] ; then
for configdir in ${configdirs} ; do
if [ -n "${verbose}" ] ; then
echo Configuring ${configdir}...
fi
if [ -d ${configdir} ] ; then
- (cd ${configdir} ;
- ./configure -recursing ${host} +target=${target} \
- ${verbose} ${subdirs} ${removing} +destdir=${destdir}) \
- | sed 's/^/ /'
+ if [ -n "${objdir}" ] ; then
+ if [ ! -d ${objdir}/${configdir} ] ; then
+ mkdir ${objdir}/${configdir}
+ fi
+ fi
+
+ POPDIR=`pwd`
+ cd ${configdir}
+
+ if (${progname} +recurring ${host_alias} +target=${target_alias} \
+ ${verbose} ${subdirs} ${removing} +ddestdir=${ddestdir} +idestdir=${idestdir} \
+ `if [ -n "${objdir}" ] ; then echo +objdir=${objdir}/${configdir} ; fi` \
+ ${tmpdiroption}) ; then
+ true
+ else
+ exit 1
+ fi
+
+ cd ${POPDIR}
+
+# (cd ${configdir} ;
+# if (${progname} +recurring ${host_alias} +target=${target_alias} \
+# ${verbose} ${subdirs} ${removing} +destdir=${destdir} \
+# `if [ -n "${objdir}" ] ; then echo +objdir=${objdir}/${configdir} ; fi` \
+# ${tmpdiroption}) ; then true ; else exit 1 ; fi) \
+# | sed 's/^/ /'
else
if [ -n "${verbose}" ] ; then
echo Warning: directory \"${configdir}\" is missing.
# Now build a Makefile for this host.
if [ -n "${subdirs}" -a ! -n "${removing}" ] ; then
+ push=`pwd`
+
+ if [ -n "${objdir}" ] ; then
+ cd ${objdir}
+ fi
+
cd ${hostsubdir}
- cat > GNUmakefile << E!O!F
-# Makefile generated by configure for host ${host}.
+ cat > GNUmakefile << 'E!O!F'
+# Makefile generated by configure for host ${host_alias}.
-ALL := $(shell ls -d Target-*)
+ALL := $(shell ls -d T-*)
%:
$(foreach subdir,$(ALL),$(MAKE) -C $(subdir) \$@ &&) true
all:
E!O!F
- cd ..
+ cd ${push}
fi
done # for each host
+### clean up.
+
+rm -f ${tmpfile}.com ${tmpfile}.tgt ${tmpfile}.hst ${tmpfile}.pos
+
exit 0
+#
#
# $Log$
-# Revision 1.33 1991/08/25 21:48:38 rich
-# Adding diff to the fray.
+# Revision 1.71 1991/11/13 20:56:11 sac
+# Passes down version_path for things which install themselves into
+# libsubdir.
#
-# Revision 1.32 1991/08/25 20:18:20 rich
-# Adding grep to the fray.
+# Revision 1.70 1991/11/13 19:49:17 sac
+# The +noversion flag will make an installation happen to the machine/..
+# directory rather than the machine/version/.. directory.
#
-# Revision 1.31 1991/08/23 04:50:57 rich
-# Minor config polish.
+# Steve
#
-# Revision 1.22 1991/08/23 03:31:43 rich
-# Minor polish & config mapping.
+# Revision 1.69 1991/11/12 04:41:21 rich
+# allow +foo bar options. stolen from texinfo configure
#
-# Revision 1.30 1991/08/22 07:15:51 rich
-# Three part names, etc.
+# Revision 1.68 1991/11/09 11:34:52 rich
+# correct a comment
#
-# Revision 1.29 1991/08/20 04:56:51 rich
-# revisiting error messages
+# Revision 1.67 1991/11/06 22:28:08 rich
+# pass +idestdir and +ddestdir
#
-# Revision 1.28 1991/08/16 19:22:17 rich
-# This is the commontargets change and should be considered
-# experimental.
+# Revision 1.66 1991/11/05 04:02:14 rich
+# don't allow +recurring to reach config.status
#
-# Revision 1.27 1991/08/08 01:14:13 rich
-# allow +f to stand in for +subdirs
+# Revision 1.65 1991/11/01 00:25:28 rich
+# new install theme
#
-# Revision 1.26 1991/08/07 19:21:32 rich
-# +forcesubdirs -> +subdirs
+# Revision 1.64 1991/10/30 06:55:25 rich
+# suck in site makefile frags first
#
-# Revision 1.25 1991/08/07 07:05:30 rich
-# Added make.
+# Revision 1.63 1991/10/25 02:07:18 steve
+# More name changing
#
-# Revision 1.24 1991/08/06 19:26:01 rich
-# revised option parsing.
+# Revision 1.62 1991/10/24 11:59:03 rich
+# add null definitions for makefile_frag_foo
#
-# Revision 1.23 1991/08/06 19:12:32 rich
-# Host-level GNUmakefiles.
+# Revision 1.61 1991/10/24 00:23:59 hgs
+# Allow for using tmake-sun4
#
-# Revision 1.22 1991/07/20 01:22:30 rich
-# propogate gdb changes and destdir fix
+# Revision 1.60 1991/10/23 21:48:28 rich
+# Makefiles should include the makefile frag names even if the makefile
+# frag doesn't exist in *this* directory. Otherwise we inherit the
+# variable setting from our parent Makefile.
#
-# Revision 1.21 1991/07/20 00:55:20 gnu
-# Roll in new configure that handles GDB. Make sure that the "configure"
-# that is checked-in reflects the latest "configure.in", which includes gdb.
+# Revision 1.59 1991/10/16 19:53:31 gnu
+# Update for SCO problems.
#
-# Revision 1.9 1991/07/06 04:35:51 gnu
-# Fix bug in configure when iterating targets.
-# Depend on alldeps.mak, not ${srcdir}/alldeps.mak, so it can be found
-# in either spot.
+# * Fix "Larry Wall kludge" line so it works. If this script is run by csh,
+# it will complain, feed itself to sh, and complain some more. But will work.
#
-# Revision 1.8 1991/07/05 00:04:58 gnu
-# Thu Jul 4 14:47:06 1991 John Gilmore (gnu at cygint.cygnus.com)
+# * Use <14 char file names in /tmp.
#
-# * configure.in, Makefile.in: Avoid rebuilding "depend" as much.
-# Avoid declaring Makefile dependencies, because GNU Make stupidly
-# tries to update it if we do.
+# Revision 1.58 1991/10/16 06:12:52 rich
+# Two small bugs. First, single quoted sed line doesn't need to quote
+# '$'. Second, use quotes around the hereis document trigger in order
+# to quote the entire contents of the hereis document.
#
-# * coffread.c: Revise for minor changes to bfd internal coff
-# indexes.
+# Revision 1.57 1991/10/11 05:31:05 gnu
+# Simplify "Using" message code. Put the message that configure prints
+# (or suppresses) into the config.status file as a comment.
#
-# * configure: If -template= is given a relative path, make it
-# absolute before recurring in subdirectories.
+# Revision 1.56 1991/10/10 05:01:47 rich
+# Remove the set -e but protect the recusion call.
#
-# Revision 1.7 1991/07/04 15:59:46 gnu
-# Make gdb work with configure. Only thing that doesn't work is the -list
-# option (as far as I know).
+# Revision 1.55 1991/10/10 04:57:23 rich
+# * Die when sub-configure's do.
+# * get the makefile building message line correct.
+# * set -e
#
-# Revision 1.6 1991/06/04 07:28:16 gnu
-# Change GDB over to GNU General Public License version 2.
+# Revision 1.54 1991/10/10 01:04:42 rich
+# Backed out the "/bin/sh config.sub" change. Fails when config.sub was
+# on PATH.
#
-# Revision 1.5 1991/05/19 07:26:54 rich
-# configure changes and -opcode.h movement.
+# Revision 1.53 1991/10/10 00:38:08 rich
+# Call config.sub as "/bin/sh config.sub" instead of directly. This
+# protects us from the case where config.sub isn't executable.
#
-# Revision 1.4 1991/05/19 00:16:45 rich
-# Configure for gdb.
+# Revision 1.52 1991/10/09 00:48:26 rich
+# Another patch from jim.
#
-# Revision 1.10 1991/05/04 00:58:38 rich
-# Fix program name bug.
+# Revision 1.51 1991/10/08 06:07:58 wilson
+# Fix bug in smake- file code.
#
-# Revision 1.9 1991/05/03 19:14:18 rich
-# Changed getopt to libiberty, commented out an aborted attempt at host
-# level Makefiles because it caused errors on +rm, add a warning for
-# directories expected to be removed on +rm but that don't exist.
+# Revision 1.50 1991/10/04 23:49:37 rich
+# Per's patch for my config.sub botch.
#
-# Revision 1.8 1991/04/24 16:50:59 rich
-# Three staging checkpoint.
+# Revision 1.49 1991/10/04 22:52:09 rich
+# Use john's heuristic for finding ourselves. kinda like hare krishna.
#
-# Revision 1.7 1991/04/17 01:34:47 rich
-# Added getopt for binutils, fixed problem with host dependancies in
-# configure.template.
+# Revision 1.48 1991/10/02 13:17:28 rich
+# take out the set -e for now
#
-# Revision 1.6 1991/04/16 00:18:44 rich
-# Now handles multiple hosts and targets.
+# Revision 1.47 1991/10/02 10:02:23 rich
+# * temporary files in TMPDIR
+# * +objdir
#
-# Revision 1.5 1991/04/15 23:43:44 rich
-# Now handles multiple hosts and targets.
+# Revision 1.46 1991/10/02 06:29:53 rich
+# Added +site=foo option for naming site specific Makefile fragments.
#
-# Revision 1.4 1991/04/13 02:11:03 rich
-# Config cut 3. We now almost install a29k.
+# Revision 1.45 1991/10/02 06:15:13 rich
+# Removed +f option. Used to stand for +forcesubdirs which is now
+# called +subdirs.
#
-# Revision 1.3 1991/04/11 02:41:54 rich
-# Cut 2 config. Subdirs.
+# Revision 1.44 1991/10/02 06:02:35 rich
+# Added rcs log line.
#
#
#
# End:
#
-# end of configure.template
+# end of configure